Permissions fail when connected to Facets 
Status: Closed   

Priority: Normal   

Assignee: Shimon Shtein   

Category: Users, Roles and Permissions   

Target version:    

Difficulty:  Fixed in Releases: 1.20.0

Triaged: No Found in Releases:  

Bugzilla link: 1569395 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5837

  

Description

Consider the following steps

1. create a role with the following filters -> [ :view_facts, (:view_hosts, :search => "content_view_id = 1")] note I used

content_view_id as the search filter for the host. You could use any facet attribute for this.

2. create a user associated to this role

3. execute api call

4.
curl -s -u 'apiuser:redhat' -k https://<url>/api/v2/hosts/3/facts

Expected:

Assuming Host with id 3 is associated to cv 1, we should get the facts

Actual:

$ curl -s -u 'apiuser:redhat' -k https://<url>/api/v2/hosts/3/facts

{

  "error": {"message":"Can't join 'Host::Base' to association named 'content_facet'; perhaps you m

isspelled it?"}

}

 Problem here is with this call -> https://github.com/theforeman/foreman/blob/develop/app/services/authorizer.rb#L62

Basically the code does the equivalent of

> FactValue.joins(:host => :content_facet).to_sql

ActiveRecord::ConfigurationError: Can't join 'Host::Base' to association named 'content_facet'; pe

rhaps you misspelled it?

 Any facet attribute associated to the host is going to hit this issue.

Associated revisions

Revision 42febfe8 - 09/14/2018 11:03 AM - Shimon Shtein

Fixes #24056 - Moved facets to Host::Base

History

#1 - 06/25/2018 03:39 AM - Partha Aji

- Bugzilla link set to 1569395

#2 - 06/25/2018 11:05 PM - The Foreman Bot
https://github.com/theforeman/foreman/blob/develop/app/services/authorizer.rb#L62


- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/5739 added

#3 - 07/11/2018 07:17 PM - Partha Aji

- Assignee changed from Partha Aji to Shimon Shtein

- Triaged set to No

#4 - 07/15/2018 03:19 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/5837 added

#5 - 09/14/2018 11:03 AM - Anonymous

- Fixed in Releases 1.20.0 added

#6 - 09/14/2018 12:01 PM - Shimon Shtein

- Status changed from Ready For Testing to Closed

Applied in changeset 42febfe84e896fbacdd84d72294430a1ee82ce69.

#7 - 09/24/2018 07:24 PM - Eric Helms

- Pull request deleted (https://github.com/theforeman/foreman/pull/5739)

#8 - 10/04/2018 04:29 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/6110 added

#9 - 11/08/2018 04:42 PM - Eric Helms

- Pull request deleted (https://github.com/theforeman/foreman/pull/6110)

#10 - 07/15/2020 01:28 PM - Tomer Brisker

- Category changed from 218 to Users, Roles and Permissions
